%global __os_install_post %(echo '%{__os_install_post}' | sed -e 's!/usr/lib[^[:space:]]*/brp-python-bytecompile[[:space:]].*$!!g')
%define debug_package %{nil}
%define __python %_bindir/python3
%global daemon_user monitor
%global backup_modules %{_sysconfdir}/op5-backup/modules/external
Name: op5-nachos
Version: %{op5version}
Release: %{op5release}%{?dist}
License: GPLv2
Vendor: OP5 AB
Url: https://www.itrsgroup.com
BuildRoot: %{_tmppath}/%{name}-%{version}
Summary: Naemon configuration management service
Group: Applications/Internet
Prefix: /opt/monitor/nachos
BuildRequires: python3-pip
Requires: mariadb-server
Requires: monitor-nacoma
Requires: python3
Requires: python3-pip
Source: %name-%version.tar.gz

%description
Naemon configuration management service

%package test
Summary: Test files for Nachos
Requires: op5-nachos
Requires: op5backup

%description test
Test tools to run feature test suite for Nachos.


%prep
%setup -q

%build
# The wheels are built in the ci_config pre step
%{__tar} cvfz dist.tar.gz dist

%install
%{__install} -Dp -m 644 dist.tar.gz %{buildroot}%{prefix}/dist.tar.gz
%{__install} -D -m 600 nachos.cfg %{buildroot}%{prefix}/nachos.cfg
%{__install} -D -m 700 init_db.sh %{buildroot}%{prefix}/init_db.sh
%{__install} -D -m 440 nachos.sudo %{buildroot}/%{_sysconfdir}/sudoers.d/nachos
%{__install} -D -m 644 nachos.service %{buildroot}%{_unitdir}/nachos.service
%{__install} -D -m 644 nachos-rsyslog.conf %{buildroot}/%{_sysconfdir}/rsyslog.d/op5-rsyslog-nachos.conf
%{__install} -D -m 644 op5-backup.sh %{buildroot}%{backup_modules}/op5-nachos
%{__mkdir} %{buildroot}%{prefix}/venv

# Use a newer pip version
%{__python} -m pip install --user --no-index -f dist/ --upgrade pip

%{__python} -m pip install --no-index --no-deps --no-warn-script-location \
	--prefix %{prefix}/test --root %{buildroot} test-wheels/*.whl


%post
%systemd_postun
systemctl stop nachos.service || exit 0
systemctl start mariadb || :
%{prefix}/init_db.sh || :


%posttrans
# Set up virtual environment
cd %{prefix}
%{__rm} -rf dist venv
python3 -m venv venv
%{__tar} xfz dist.tar.gz
# First install the pip version that was used in the build
venv/bin/pip -q install --upgrade --no-index -f dist pip
# Then install all the remaining packages
%{__rm} -f dist/pip-*.whl
venv/bin/pip -q install --upgrade --no-index --no-deps dist/*.whl
# Sync database schema to current version.
%{prefix}/venv/bin/nachos-manage --config-file %{prefix}/nachos.cfg db_sync

# Remove build artifacts
%{__rm} -rf %{prefix}/dist

systemctl daemon-reload
# Restart rsyslog for the new logging rules
systemctl restart rsyslog
systemctl start nachos.service
systemctl enable nachos.service


%preun
%systemd_preun nachos.service

if [ $1 -eq 0 ] ; then
	# Manually remove venv/ created in %posttrans.
    %{__rm} -rf %{prefix}/venv
fi


%files
%{prefix}
%exclude %{prefix}/test
%ghost %{prefix}/venv
%attr(-, monitor, -) %config(noreplace) %{prefix}/nachos.cfg
%{_sysconfdir}/sudoers.d/nachos
%{_unitdir}/nachos.service
%{_sysconfdir}/rsyslog.d/op5-rsyslog-nachos.conf
%{backup_modules}

%files test
%{prefix}/test


%clean
%{__rm} --recursive --force %buildroot


%changelog
* Wed Dec  2 2020 Aksel Sjögren <asjogren@itrsgroup.com>
- Remove MySQL user 'nachos'@'%'
- Remove support for EL6 and use default Python 3 from target system.
* Wed Oct 28 2020 Erik Sjöström <esjostrom@itrsgroup.com>
- Remove build artifacts in posttrans
* Mon Oct 14 2019 Petter Nyström <pnystrom@op5.com>
- Include dependent wheels in RPM (no more relocatable venv)
* Fri May 18 2018 Robin Engström <rengstrom@op5.com>
- Add systemd files
* Tue May 15 2018 Robin Engström <rengstrom@op5.com>
- Initialize database on install
* Thu Apr 19 2018 Robin Engström <rengstrom@op5.com>
- Initial build
